import { EventEmitter } from '@angular/core';
import { ViewController } from '../nav/view-controller';
/**
 * @name Picker
 * @description
 *
 */
export declare class Picker extends ViewController {
    ionChange: EventEmitter<any>;
    constructor(opts?: PickerOptions);
    /**
    * @private
    */
    getTransitionName(direction: string): any;
    /**
     * @param {any} button Picker toolbar button
     */
    addButton(button: any): void;
    /**
     * @param {any} button Picker toolbar button
     */
    addColumn(column: PickerColumn): void;
    getColumns(): PickerColumn[];
    refresh(): void;
    /**
     * @param {string} cssClass CSS class name to add to the picker's outer wrapper.
     */
    setCssClass(cssClass: string): void;
    static create(opts?: PickerOptions): Picker;
}
export interface PickerOptions {
    buttons?: any[];
    columns?: PickerColumn[];
    cssClass?: string;
    enableBackdropDismiss?: boolean;
}
export interface PickerColumn {
    name?: string;
    selectedIndex?: number;
    prefix?: string;
    suffix?: string;
    options?: PickerColumnOption[];
    cssClass?: string;
    columnWidth?: string;
    prefixWidth?: string;
    suffixWidth?: string;
    optionsWidth?: string;
}
export interface PickerColumnOption {
    text?: string;
    value?: any;
    disabled?: boolean;
}
